<h1 class="title">Решение вопросов при установке и настройке АТС-коннектора «Простые звонки – Asterisk»</h1>

<h2>1. Структура файлов АТС-коннектора и настройка уровня логирования</h2>
<hr>

<p>Расположение файлов АТС-коннектора:</p>
<ul>
	<li>файл АТС-коннектора <i>libProtocolLib.so</i> - директория /usr/lib (/usr/lib64 для 64х битной ОС)</li>
	<li>файл АТС-коннектора <i>cel_prostiezvonki.so</i> - директория /usr/lib/asterisk/modules</li>
	<li>файл конфигурации <i>cel_prostiezvonki.conf</i> - директория /etc/asterisk</li>
	<li>файлы <i>*.pem</i> - директория /etc/asterisk</li>
</ul>

<p>1.1. Установите уровень лога АТС-коннектора в отладочный.</p>

<p>Если у вас чистый Asterisk: задайте в файле <i>/etc/asterisk/cel_prostiezvonki.conf</i> значение параметра
<strong>log_level</strong> в <strong>debug</strong>.</p>

<p>Если у вас FreePBX: на странице настроек Application->Prostie Zvonki задайте параметр <strong>"Уровень
записи лога"</strong> в значение <strong>debug</strong>.</p>

<p>1.2. Перезапустите Asterisk или FreePBX.</p>

<p>1.3. В папке <i>/var/log/asterisk/</i> найдите и откройте самый свежий файл с названием
<i>cel_prostiezvonki_***.log</i></p>

<p>Проверить текущее состояние АТС-коннектора, посмотреть подключенных к нему CRM пользователей и
скачать лог файлы можно в <a target="_blank" href="Ustanovka_nastroyka_Statistika.html">веб-интерфейсе модуля «Статистика звонков»</a>.</p>

<h2>2. Проверка работоспособности АТС-коннектора</h2>
<hr>

<p>2.1. При запуске Asterisk модуля «Простые звонки» в лог файл выводится информацию о лицензии. <br>
Пример:<br>
set license status to 1 <br>
set max clients(1c_8.3) to 50</p>

<p>В этом примере АТС-коннектор успешно получил от сервера лицензирования информацию о том, что к
нему могут одновременно подключиться не более 50 пользователей 1С 8.3.</p>

<p>Если в лог файле вы не видите похожее сообщение, обратитесь к пункту <a href="#point_3.2">3.2. АТС-коннектор не получает
информацию от сервера лицензий</a></p>

<p>2.2. После того как вы настроите модуль «Простые звонки» в своей CRM системе, в лог файле появятся
сообщения, которые говорят о подключении CRM модулей: </p>

<p>New client connected: GUID c5cb767d-0021-4847-b9a4-2930d4be55f2, ClientType Excel, PhoneNumber 100,
BroadcastGroup , BroadcastEventsMask 4, EventsMode , EventsMask , ProtocolVersion 1</p>

<p>Данная строка говорит о том, что к АТС-коннектору подключился пользователь CRM (в данном случае
это «Простые звонки – Excel») с внутренним номером 100.</p>

<p>Если при попытке подключения пользователя CRM в лог файле вы видите такое сообщение: 
No valid license for Excel type <br>
Authorization error: server license expired! <br>
обратитесь к пункту <a href="#point_3.3">3.3. АТС-коннектор блокирует подключение пользователя CRM системы.</a></p>

<p>2.3. При входящем звонке в лог файле появляется подобное сообщение:</p>

<p>OnTransferedIncomingCall event: callID = 1111111111111, source = 89123456789, destination = 100, line =
from-trunk <br>
PBX event was pushed to 1 clients</p>

<p>Первая строка сообщения говорит о том, что АТС-коннектор отправил уведомление о входящем звонке
пользователю CRM с внутренним номером «100».<br>
Вторая строка говорит о том, что на момент отправки уведомления CRM пользователь с номером «100»
был подключен к АТС-коннектору. Если у пользователя открыта CRM система, в которой правильно
настроен модуль «Простые звонки», то в CRM системе пользователь увидит уведомление о входящем
звонке с номера «89123456789»</p>

<p>Если при входящем звонке в лог файле вы не видите подобных сообщений, обратитесь к пункту <a href="#point_3.4">3.4. В
CRM системе не отображаются уведомления о входящем звонке, не сохраняется информация о
завершившихся звонках</a></p>

<p>2.4. При ответе пользователя на входящий звонок в лог файле должно появиться подобное сообщение:</p>

<p>onTransferredAnswer event: callID = 1111111111111, source = 89123456789, destination = 100, line = fromtrunk <br>
PBX event was pushed to 1 clients</p>

<p>Сообщение говорят о том, что CRM пользователь с номером «100» ответил на входящий звонок</p>

<p>2.5. При завершении входящего звонка в лог файле появится подобное сообщение:</p>

<p>OnCallFinished event: callID = 1111111111111, source = 89123456789, destination = 100, start = 1458205200, end = 1458205278, duration = 78, direction = 0, record = http://atsoffice/record.wav, line = from-trunk <br>
PBX event was pushed to 1 clients</p>

<p>Сообщение говорит о том, что CRM пользователю c номером «100» отправлено событие о завершении
входящего звонка с номера «89123456789», а также ссылка на аудиозапись этого звонка
http://atsoffice/record.wav</p>

<p>Обратите внимание, что ссылка на аудиозапись должна «открываться» в браузере на компьютере
пользователя.</p>

<p>Если при завершении звонка в лог файле вы не видите подобных сообщений, обратитесь к пункту <a href="#point_3.4">3.4. В
CRM системе не отображаются уведомления о входящем звонке, не сохраняется информация о
завершившихся звонках</a></p>

<p>2.6. При совершении звонка из CRM системы (пользователь щелкнул по номеру телефона) в лог файле
появится подобное сообщение:</p>

<p>Call event from CRM: src = 100, dst = 89123456789</p>

<p>Это сообщение говорит о том, что пользователь с номером «100» совершает исходящий звонок на номер
«89123456789».</p>

<p>Если при совершении исходящего звонка из CRM системы в лог файле не появляется подобное
сообщение, обратитесь к пункту <a href="#point_3.5">3.5. Исходящий звонок не происходит после щелчка по номеру
телефона в CRM системе</a></p>

<p>2.7. При начале исходящего звонка в лог файле появится подобное сообщение:</p>

<p>onOutcomingCall event: callID = 2222222222222, source = 100, destination = 89123456789 <br>
PBX event was pushed to 1 clients</p>

<p>Это сообщение говорит о том, что АТС выполняет набор номера «89123456789» для пользователя с
внутренним номером «100».</p>

<p>Обратите внимание, что не все CRM системы обрабатывают это сообщение. Если в руководстве
пользователя CRM модуля «Простые звонки» описана эта возможность и она не работает, обратитесь к
пункту <a href="#point_3.4">3.4. В CRM системе не отображаются уведомления о входящем звонке, не сохраняется
информация о завершившихся звонках</a></p>

<p>2.8. При ответе удаленного абонента на исходящий звонок в лог файле появится подобное сообщение:</p>

<p>onOutcomingAnswer event: callID = 2222222222222, source = 100, destination = 789123456789
PBX event was pushed to 1 clients</p>

<p>Это сообщение говорит о том, что удаленный абонент, которому пользователь с внутренним номером
«100» звонил на номер «789123456789», ответил на исходящий звонок.</p>

<p>2.9. При завершении звонка в лог файле появится подобное сообщение:</p>

<p>OnCallFinished event: callID = 2222222222222, source = 100, destination = 89123456789, start =
1457935441, end = 1457935921, duration = 480, direction = 1, record = http://atsoffice/record.wav line = <br>
PBX event was pushed to 1 clients</p>

<p>Сообщение говорит о том, что CRM пользователю c внутренним номером «100» отправлено событие о
завершении исходящего звонка на номер «89123456789», а также ссылка на аудиозапись этого звонка
http://atsoffice/record.wav</p>

<p>Обратите внимание, что ссылка на аудиозапись должна «открываться» в браузере на компьютере
пользователя.</p>

<p>Если при завершении звонка в лог файле вы не видите подобных сообщений, обратитесь к пункту <a href="#point_3.4">3.4. В
CRM системе не отображаются уведомления о входящем звонке, не сохраняется информация о
завершившихся звонках</a></p>

<h2>3. Возможные проблемы и пути их решения</h2>
<hr>

<h3>3.1. Asterisk не загружает модуль. Модуль не появляется в списке загруженных модулей.</h3>

<p><u>Признаки неисправности</u> <br> 
В логах Asterisk появляются строки: <br>
WARNING[24526] loader.c: Error loading module 'cel_prostiezvonki.so': <br>
/usr/lib64/asterisk/modules/cel_prostiezvonki.so: undefined symbol: ast_format_set <br>
WARNING[24526] loader.c: Module 'cel_prostiezvonki.so' could not be loaded.</p>

<p><u>Причина</u>
Версия модуля «Простые звонки» не соответствует версии Asterisk. Например, модуль «Простые звонки»
для Asterisk 1.8 установлен в Asterisk 11.</p>

<p><u>Решение</u>
Обратитесь в <a target="_blank" href="http://prostiezvonki.ru/support">службу технической поддержки</a>, чтобы получить ссылки на скачивание модуля для нужной
вам версии Asterisk. </p>

<h3><a name="point_3.2">3.2. АТС-коннектор не получает информацию от сервера лицензий или получает ее некорректно</a>.</h3>

<p><u>Признаки неисправности</u> <br>
В логах АТС-коннектора появляются строки: <br>
set license status to 0 <br>
License server successfully set license status <br>
или <br>
Authorization error: server license expired!</p>

<p><u>Причина 1</u> <br>
1. Версия АТС-коннектора «Простые звонки» не соответствует версии Asterisk. Например, модуль
«Простые звонки» для Asterisk 1.8 установлен в Asterisk 11.</p>

<p><u>Решение 1</u> <br>
Если версия АТС-коннектора не соответствует версии Asterisk. Обратитесь в <a target="_blank" href="http://prostiezvonki.ru/support">службу технической
поддержки</a>, чтобы получить ссылки на скачивание модуля для нужной вам версии Asterisk.</p>

<p><u>Причина 2</u> <br>
АТС-коннектор не может получить доступ в сеть Интернет для проверки лицензии.</p>

<p><u>Решение 2</u> <br>
Для проверки лицензионного ключа АТС-коннектор связывается (по протоколу HTTPS) с портом 443
сервера лицензий, который размещен в Интернет. Пожалуйста, проверьте настройки своего файрвола,
чтобы разрешить доступ АТС-коннектора к серверу лицензий.</p>

<p><u>Причина 3</u> <br>
В конфигурационном файле АТС-коннектора (или в окне настроек АТС-коннектора для FreePBX)
лицензионный ключ указан неверно.</p>

<p><u>Решение 3</u> <br>
Задайте правильный лицензионный ключ из email сообщения с демо-версией.</p>

<p><u>Причина 4</u> <br>
Время действия демо-версии или ограниченной по времени лицензии истекло.</p>

<p><u>Решение 4</u> <br>
Если вы не успели протестировать продукт, отправьте запрос на продление демо-версии в <a target="_blank" href="http://prostiezvonki.ru/support">службу
технической поддержки</a> (обязательно укажите лицензионный ключ в тексте письма) или обратитесь в
отдел продаж для покупки лицензии.</p>

<h3><a name="point_3.3">3.3. АТС-коннектор блокирует подключение пользователя CRM системы</a></h3>


<p><u>Признаки неисправности</u> <br>
При попытке подключения пользователя CRM в лог файле появляются подобные сообщения: <br>
No valid license for Excel type <br>
Authorization error: server license expired!</p>

<p><u>Причина</u> <br>
Вы пытаетесь подключиться из CRM, лицензия на интеграцию с которой отсутствует. <br>
Например: <br>
<ul>
	<li>Демо-версия для 1С 8.2, а к АТС-коннектору подключается пользователь 1С 8.3</li>
	<li>Демо-версия для облачной версии Битрикс24, а пытаетесь подключиться из коробочной версии Битрикс24</li>
	<li>Демо-версия для amoCRM, а к подключается пользователь из Битрикс24</li>
</ul>
</p>

<p><u>Решение</u> <br>
Подключайтесь к АТС-коннектору пользователями тех CRM, для которых вы заказывали демо-версию
или приобретали лицензии.</p>

<p>Если вы хотите попробовать интеграцию с другой CRM, отправьте запрос в <a target="_blank" href="http://prostiezvonki.ru/support">службу технической
поддержки</a> (обязательно укажите лицензионный ключ в тексте письма). Мы добавим в ваш
лицензионный ключ возможность тестирования другой CRM системы.</p>

<h3><a name="point_3.4">3.4. В CRM системе не отображаются уведомления о входящем звонке, не сохраняется информация о завершившихся звонках</a></h3>

<p><u>Признаки неисправности 1</u> <br>
В лог файле нет подобных сообщений о входящем или завершенном звонке:
OnTransferedIncomingCall event: callID = 1111111111111, source = 89123456789, destination = 100, line =
from-trunk</p>

<p><u>Причина 1</u> <br>
Не настроен файл cel.conf</p>

<p><u>Решение 1</u> <br>
Выполните команду: <br>
asterisk -rx "cel show status" | grep Application <br>
Файл cel.conf не настроен, если в ответе команды вы не видите строк: <br>
CEL Tracking Application: mixmonitor <br>
CEL Tracking Application: dial <br>
CEL Tracking Application: park <br>
в архиве с нашим модулем есть пример файла cel.conf, убедитесь, что используемый у вас файл cel.conf
соответствует файлу из архива</p>

<p><u>Признаки неисправности 2</u> <br>
В лог файле после сообщения о входящем или завершенном звонке есть строчка «PBX event was pushed
to 0 clients»: <br>
OnTransferedIncomingCall event: callID = 1111111111111, source = 89123456789, destination = 100, line =
from-trunk <br>
PBX event was pushed to 0 clients</p>

<p><u>Причина 2</u> <br>
Пользователь CRM с таким внутренним номером не подключен к АТС-коннектору.</p>

<p><u>Решение 2</u> <br>
1. Проверьте настройки модуля «Простые звонки» в CRM системе. Модуль должен быть правильно
настроен и подключен к АТС-коннектору. <br>
2. Проверьте настройки рабочего места пользователя. На время установки, настройки и тестирования мы
рекомендуем отключить программу файрвол и антивирус, а также плагины для браузера Google Chrome,
которые блокируют загрузку содержимого страницы из внешних ресурсов и всплывающие окна (AdBlock
и т.п.).</p>

<h3><a name="point_3.5">3.5. Исходящий звонок не происходит после щелчка по номеру телефона в CRM системе</a></h3>

<p><u>Причина 1</u> <br>
У пользователя не настроен аппаратный или программный телефон, подключенный к АТС.</p>	
<p><u>Решение 1</u> <br>
«Простые звонки» не заменяют аппаратный или программный телефон, подключенный к АТС. Поэтому у
пользователя должен быть настроен телефон или софтфон, с помощью которого он может совершать и
принимать звонки через АТС без участия «Простых звонков».</p>	
<p><u>Причина 2</u> <br>
Внутренний номер, настроенный в аппаратном телефоне или софтфоне, не соответствует внутреннему
номеру пользователя, указанному в CRM модуле «Простые звонки».</p>	
<p><u>Решение 2</u> <br>
В CRM модуле «Простые звонки» укажите для пользователя тот внутренний номер, который настроен в
аппаратном телефоне или софтфоне этого пользователя.</p>	
<p><u>Причина 3</u> <br>
После совершения звонка из CRM, на телефон или софтфон пользователя поступает входящий звонок,
на который нужно ответить. Пользователь не отвечает на этот входящий звонок.</p>	
<p><u>Решение 3</u> <br>
Пользователь должен ответить на входящий звонок. После этого АТС наберет номер, по которому
пользователь щелкал в CRM системе.</p>	

<h3>3.6. Не работает умный перевод на ответственного сотрудника</h3>

<p><u>Признаки неисправности</u> <br>
В CRM модуле «Простые звонки» есть функция «Умный перевод» и она включена согласно руководству
по установке и настройке соответствующего CRM модуля.
Наличие функции «Умный перевод» в используемом вами CRM модуле вы можете проверить в таблице:
<a target="_blank" href="http://prostiezvonki.ru/supportedsystems#matrix">http://prostiezvonki.ru/supportedsystems#matrix</a> </p>
<p><u>Причина</u> <br>
Нет вызова макроса «prostie-zvonki» в dial-плане Asterisk. </p>
<p><u>Решение</u> <br>
В файле cel_prostiezvonki.conf нужно проверить параметр smart_transfer, если он включен (знач. "on"), то
должен быть прописан вызов макроса Macro(prostie-zvonki) в Dialplan'e входящих звонков.
Иначе, если умная переадресация не нужна, и соотв. вызова макроса нет, тогда нужно поставить
значение параметра smart_transfer в "off" </p>

<h2>4. Не нашли решение своего вопроса?</h2>
<hr>

<p>4.1. Установите уровень лога АТС-коннектора в отладочный.</p>

<p>Если у вас чистый Asterisk: задайте в файле <i>/etc/asterisk/cel_prostiezvonki.conf</i> значение параметра
<strong>log_level</strong> в <strong>debug</strong>.</p>

<p>Если у вас FreePBX: на странице настроек Application->Prostie Zvonki задайте параметр <strong>"Уровень
записи лога"</strong> в значение <strong>debug</strong>.</p>

<p>4.2. Перезапустите Asterisk или FreePBX.</p>

<p>4.3. В папке <i>/var/log/asterisk/</i> найдите файлы с названиями <i>cel_prostiezvonki_***.log.</i> Отправьте их
вложением по email в <a target="_blank" href="http://prostiezvonki.ru/support">службу технической поддержки</a>, обязательно сопроводите логи подробным
описанием ситуации с которой вы столкнулись.</p>






